/*

   Options dialog

   Set engines order and change preferences

*/

var groowe_SearchEngines = null;
var groowe_Favorites = null;
var affiliate = "-----x-----";
var language = "en-US";


function Groowe_FavEdit()
{
   var lb = document.getElementById("Groowe-Opt-Favorites");
   var index = lb.selectedIndex;
   if (index != -1) {
      var se = lb.childNodes.item(index).attributes.getNamedItem("label").nodeValue
      //var lang = document.getElementById("Groowe-Opt-Languages").value;
      window.openDialog("chrome://groowebar/content/edittoolbar.xul", "Edit " + se + " Toolbar", "centerscreen,chrome,modal", se);
   }
   else {
      alert("Select the toolbar first");
   }
}

//
// Move favorite item one place up
//
function Groowe_FavMoveUp()
{
   try {
      var lb = document.getElementById("Groowe-Opt-Favorites");
      var index = lb.selectedIndex;

      if (index != 0) {
         var label = lb.childNodes.item(index).attributes.getNamedItem("label").nodeValue;
         var tempItem = lb.childNodes.item(index);

         if ((index == 2) && (lb.childNodes.item(1).attributes.getNamedItem("label").nodeValue == affiliate)) {
            var tempItem2 = lb.childNodes.item(0);
            lb.removeChild(lb.childNodes.item(index));
            lb.removeChild(lb.childNodes.item(0));
            lb.insertBefore(tempItem, lb.childNodes.item(0));
            lb.insertBefore(tempItem2, lb.childNodes.item(2));
         }
         else {
            lb.removeChild(lb.childNodes.item(index));
            lb.insertBefore(tempItem, lb.childNodes.item(index-1));
         }
         lb.selectedItem = tempItem;
      }
   }
   catch (e) {
      // alert(e);
   }
}



//
// Move favorite item one place down
//
function Groowe_FavMoveDown()
{
   try {
      var lb = document.getElementById("Groowe-Opt-Favorites");
      var index = lb.selectedIndex;

      if (index != lb.childNodes.length-1) {
         var label = lb.childNodes.item(index).attributes.getNamedItem("label").nodeValue;

         if ((index == 1) && (label == affiliate)) {
            alert("Groowe is affiliated with this site and it can't be moved down.\nAffiliated sites help us to continue Groowebar development.");
            return;
         }
         lb.removeChild(lb.childNodes.item(index));

         var tempItem = null;
         tempItem = document.createElement("listitem");
         var tmp = groowe_SearchEngines[label].split("||");
         tempItem.setAttribute("class", "listitem-iconic");

         if ((tmp[0].length > 7) && (tmp[0].substr(0, 7) == "http://")) {
            tempItem.setAttribute("image", tmp[0]);
         }
         else {
            tempItem.setAttribute("image", "chrome://groowebar/skin/icons/" + tmp[0] + ".png");
         }

         tempItem.setAttribute("label", label);
         lb.insertBefore(tempItem, lb.childNodes.item(index+1));
         lb.selectedItem = tempItem;
      }
   }
   catch (e) {
      // alert(e);
   }
}



//
// Remove item from favorites
//
function Groowe_RemoveFromFavorites()
{
   try {
      var lb = document.getElementById("Groowe-Opt-Favorites");
      if (lb.childNodes.item(lb.selectedIndex).attributes.getNamedItem("label").nodeValue == affiliate) {
         alert("Groowe is affiliated with this site and it can't be removed from the favorites.\nAffiliated sites help us to continue Groowebar development.");
         return;
      }
      lb.removeChild(lb.childNodes.item(lb.selectedIndex));
      Groowe_PoluteAllEngines();
   }
   catch (e) {
      // alert(e);
   }
}



//
// Add item to favorites
//
function Groowe_AddToFavorites()
{
   try {
      var lbFav = document.getElementById("Groowe-Opt-Favorites");
      var lbAll= document.getElementById("Groowe-Opt-AllEngines");
      var index = lbAll.selectedIndex;
      if (index != -1) {
         var label = lbAll.childNodes.item(index).attributes.getNamedItem("label").nodeValue;
         var tempItem = null;
         tempItem = document.createElement("listitem");
         var tmp = groowe_SearchEngines[label].split("||");
         tempItem.setAttribute("class", "listitem-iconic");
         if ((tmp[0].length > 7) && (tmp[0].substr(0, 7) == "http://")) {
            tempItem.setAttribute("image", tmp[0]);
         }
         else {
            tempItem.setAttribute("image", "chrome://groowebar/skin/icons/" + tmp[0] + ".png");
         }
         tempItem.setAttribute("label", label);
         lbFav.appendChild(tempItem);
         lbFav.selectedItem = tempItem;
         Groowe_PoluteAllEngines();
      }
   }
   catch (e) {
      // alert(e);
   }
}


//
// Save options to preferences
//
function Groowe_SaveOptions()
{
   try {
      groowe_Favorites = new Array();
      var lbFav= document.getElementById("Groowe-Opt-Favorites");
      for (var i = 0 ; i < lbFav.childNodes.length; i++) {
         groowe_Favorites.push(lbFav.childNodes.item(i).attributes.getNamedItem("label").nodeValue);
      }
      var favorites = groowe_Favorites.join("||");
      var branch = groowe_prefs.getBranch("groowebar.");
      branch.setCharPref("Favorites", favorites);
      branch.setBoolPref("ShowHighlight", document.getElementById("Groowe-Opt-Highlight").checked);
//      branch.setBoolPref("ShowHide", document.getElementById("Groowe-Opt-Hide").checked);
      branch.setBoolPref("ShowAmazon", document.getElementById("Groowe-Opt-Amazon").checked);
      branch.setBoolPref("NewTab", document.getElementById("Groowe-Opt-NewTab").checked);
      branch.setBoolPref("ShowFindOnPage", document.getElementById("Groowe-Opt-Find").checked);
      branch.setBoolPref("ShowCaptions", document.getElementById("Groowe-Opt-Captions").checked);
      branch.setBoolPref("AutoSelect", document.getElementById("Groowe-Opt-Auto").checked);
      branch.setBoolPref("ClearOnExit", document.getElementById("Groowe-Opt-ClearOnExit").checked);
      //branch.setCharPref("Language", document.getElementById("Groowe-Opt-Languages").value);
      branch.setBoolPref("IsChanged", true);
   }
   catch (e) {
      //alert(e);
   }
}



//
// Load options at dialog startup
//
function Groowe_LoadOptions()
{
   try {
      // default settings
      var showHighlight = true;
      var showFindOnPage = true;
//      var showHide = true;
      var showAmazon = true;
      var showCaptions = true;
      var clearOnExit = false;
      var autoSelect = true;
      var newTab = false;

      var branch = groowe_prefs.getBranch("groowebar.");

      // try to load settings, if value doesn't exists, default one will be used
//      try {showHide = branch.getBoolPref("ShowHide");} catch (e) {}
      try {showAmazon = branch.getBoolPref("ShowAmazon");} catch (e) {}
      try {newTab = branch.getBoolPref("NewTab");} catch (e) {}
      try {showHighlight = branch.getBoolPref("ShowHighlight");} catch (e) {}
      try {showFindOnPage = branch.getBoolPref("ShowFindOnPage");} catch (e) {}
      try {showCaptions = branch.getBoolPref("ShowCaptions");} catch (e) {}
      try {autoSelect = branch.getBoolPref("AutoSelect");} catch (e) {}
      try {clearOnExit = branch.getBoolPref("ClearOnExit");} catch (e) {}
      try {language = branch.getCharPref("Language");} catch (e) {}

      // update form controls
      document.getElementById("Groowe-Opt-Highlight").checked = showHighlight;
//      document.getElementById("Groowe-Opt-Hide").checked = showHide;
      document.getElementById("Groowe-Opt-Amazon").checked = showAmazon;
      document.getElementById("Groowe-Opt-NewTab").checked = newTab;
      document.getElementById("Groowe-Opt-Find").checked = showFindOnPage;
      document.getElementById("Groowe-Opt-Auto").checked = autoSelect;
      document.getElementById("Groowe-Opt-Captions").checked= showCaptions;
      document.getElementById("Groowe-Opt-ClearOnExit").checked = clearOnExit;
      //document.getElementById("Groowe-Opt-Languages").value = language;

      // get list of all available engines
      Groowe_EnumerateEngines(language);

      // get favorites
      try {favorites = branch.getCharPref("Favorites");} catch (e) {}
      try {
         if ((favorites != null) && (favorites != "")) {
            groowe_Favorites = favorites.split("||");
         }
      }
      catch (e) {
         groowe_Favorites = groowe_FavoritesEx;
      }


      // put engines in list boxes
      Groowe_PoluteFavorites();
      Groowe_PoluteAllEngines();
   }
   catch (e) {
      //alert(e);
   }
}



//
// Fill favorites listbox with favorits engines
//
function Groowe_PoluteFavorites()
{
   var lb= document.getElementById("Groowe-Opt-Favorites");

   for (var i = lb.childNodes.length-1; i >= 0; i--) {
      lb.removeChild(lb.childNodes.item(i));
   }

   for (var key in groowe_Favorites) {
      try {
         var tempItem = null;
         tempItem = document.createElement("listitem");
         tempItem.setAttribute("label", groowe_Favorites[key]);
         var tmp = groowe_SearchEngines[groowe_Favorites[key]].split("||");
         tempItem.setAttribute("class", "listitem-iconic");
         if ((tmp[0].length > 7) && (tmp[0].substr(0, 7) == "http://")) {
            tempItem.setAttribute("image", tmp[0]);
         }
         else {
            tempItem.setAttribute("image", "chrome://groowebar/skin/icons/" + tmp[0] + ".png");
         }
         lb.appendChild(tempItem);
      }
      catch (e) {
         //
      }
   }
}



//
// Fill all engines list box with engines
// Exclure engines already placed in favorites
//
function Groowe_PoluteAllEngines()
{
   var lbFav= document.getElementById("Groowe-Opt-Favorites");
   var lbAll= document.getElementById("Groowe-Opt-AllEngines");

   for (var i = lbAll.childNodes.length-1; i >= 0; i--) {
      lbAll.removeChild(lbAll.childNodes.item(i));
   }

   for (var key in groowe_SearchEngines) {
      var process = true;
      // is item in favorites
      for (var i = 0 ; i < lbFav.childNodes.length; i++) {
         if (key == lbFav.childNodes.item(i).attributes.getNamedItem("label").nodeValue) {
            process = false;
            break;
         }
      }

      // if it is not in favorites, add to all engines list
      if (process) {
         var tempItem = null;
         tempItem = document.createElement("listitem");
         tempItem.setAttribute("label", key);
         var tmp = groowe_SearchEngines[key].split("||");
         tempItem.setAttribute("class", "listitem-iconic");
         if ((tmp[0].length > 7) && (tmp[0].substr(0, 7) == "http://")) {
            tempItem.setAttribute("image", tmp[0]);
         }
         else {
            tempItem.setAttribute("image", "chrome://groowebar/skin/icons/" + tmp[0] + ".png");
         }
         lbAll.appendChild(tempItem);
      }
   }
   Groowe_CheckPlugin();
}






function Groowe_EnumerateEngines(groowe_language)
{
   try {
      // initialize global arrays
      groowe_SearchEngines = new Array();

      // local vars
      var arr_engines = [];

      // read engines from plugin dir
      var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
      file.append("GrooweFiles");
      try {
         var entries = file.directoryEntries;
         while(entries.hasMoreElements()) {
            var entry = entries.getNext();
            entry.QueryInterface(Components.interfaces.nsIFile);
            try {
               if (entry.leafName.substr(entry.leafName.length-4, 4).toLowerCase() == ".xml") {
                  arr_engines.push(entry.leafName.substr(0, entry.leafName.length-4));
               }
            }
            catch (e) {
               //
            }
         }
      }
      catch (e) {
         // GrooweFiles folder exists
      }

      // read engines from XML
      xmlContent = Groowe_GetContents("chrome://groowebar/content/data/engines.xml");
      var parser = new DOMParser();
      var dom = parser.parseFromString(xmlContent, "text/xml");
      var nodeList = dom.documentElement.getElementsByTagName("Engine");
      for (var i = 0; i < nodeList.length; i++) {
         arr_engines.push(nodeList.item(i).textContent);
      }

      // open each engine and read icon name
      for (var i = 0; i < arr_engines.length; i++) {
         try {
            var engineName = arr_engines[i];
            var engineXml = Groowe_GetContents("chrome://groowebar/content/data/engines/" + engineName + ".xml");
            if (engineXml == "") {
               engineXml = Groowe_GetPluginContent(engineName);
            }
            var engineParser = new DOMParser();
            var engineDom = engineParser.parseFromString(engineXml, "text/xml");
            var iconName = (engineDom.documentElement.getElementsByTagName("Icon").item(0).attributes.getNamedItem("IconID") != null) ? engineDom.documentElement.getElementsByTagName("Icon").item(0).attributes.getNamedItem("IconID").nodeValue : "";
            groowe_SearchEngines[engineName] = iconName + "|| ";
         }
         catch (e) {
            //alert(e);
         }
      }
      groowe_SearchEngines.sort();
   }
   catch (e) {
       //alert(e);
   }
}

function Groowe_HelpOptions()
{
   const url = "http://groowe.com/help/options.php";
   const newTab = window.opener.getBrowser().addTab(url);
   window.opener.getBrowser().selectedTab = newTab;

}


function Groowe_DeletePlugin()
{
   try {
      if (confirm("Delete selected plugin?")) {
         var lbAll= document.getElementById("Groowe-Opt-AllEngines");

         var index = lbAll.selectedIndex;
         if (index != -1) {
            var fileName = lbAll.childNodes.item(index).attributes.getNamedItem("label").nodeValue;
            var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
            file.append("GrooweFiles");
            file.append(fileName + ".xml");
            file.remove(false);
            Groowe_EnumerateEngines(language);
            Groowe_PoluteAllEngines();
         }
      }
   }
   catch (e) {
//      alert(e);
   }
}

function Groowe_CheckPlugin()
{
   try {
      var lbAll= document.getElementById("Groowe-Opt-AllEngines");
      var btnDel= document.getElementById("Groowe-BtnDeletePlugin");

      var index = lbAll.selectedIndex;
      if (index != -1) {
         var fileName = lbAll.childNodes.item(index).attributes.getNamedItem("label").nodeValue;

         var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
         file.append("GrooweFiles");
         file.append(fileName + ".xml");

         btnDel.disabled = !file.exists();
      }
      else {
         btnDel.disabled = true;
      }
   }
   catch (e) {
      btnDel.disabled = true;
   }
}

function Groowe_PluginsPage()
{
   const url = "http://www.groowe.com/firefox_toolbar_plugins.php";
   const newTab = window.opener.getBrowser().addTab(url);
   window.opener.getBrowser().selectedTab = newTab;
   window.close();
}
